<?php
# For security reasons, these lines should be 
# included from a file above the web directory
define( 'FM_HOST', '127.0.0.1' );
define( 'FM_FILE', 'Product Catalog' );
define( 'FM_USER', 'esmith' );
define( 'FM_PASS', 'm4rg0t' );

# this is the include for the API for PHP
require_once ('FileMaker.php');

# instantiate a new FileMaker object
$fm = new FileMaker(FM_FILE, FM_HOST, FM_USER, FM_PASS);

# create a new search transaction
if(empty($_GET['search'])) {
    $search = '';
    $request = $fm->newFindAllCommand('Product');
} else {
    $search = $_GET['search'];
    $request = $fm->newFindCommand('Product');
    $request->addFindCriterion('Name', $search);
}

# specify sort by field, if any
if(!empty($_GET['sortby'])) {
    $request->addSortRule($_GET['sortby'], 1);
}

# execute the search transaction
$result = $request->execute();

# get the result record set as an array of record objects
$records = $result->getRecords();

# loop through record objects compiling row html
$rows = '';
foreach ($records as $record) {
    $rows .= '<tr>';
    $rows .= '<td><a href="06_05.php?recid='.$record->getRecordId().'">view</a></td>';
    $rows .= '<td>'.$record->getField('ID').'</td>';
    $rows .= '<td>'.$record->getField('Name').'</td>';
    $rows .= '<td>'.$record->getField('Model Number').'</td>';
    $rows .= '<td>'.$record->getField('Price').'</td>';
    $rows .= '<td>'.$record->getField('Created At').'</td>';
    $rows .= '<td>'.$record->getField('Created By').'</td>';
    $rows .= '</tr>';
}

?>
<html>
    <head>
        <title>07_01</title>
    </head>
    <body>
        <form action="07_01.php" method="get">
            <p>
                Product Name Search: 
                <input type="text" name="search" />
                <input type="submit" value="Go" />
            </p>
        </form>
        <table border="1">
            <tr>
                <th>View</th>
                <th><a href="07_01.php?search=<?php echo $search ?>&sortby=ID">ID</a></th>
                <th><a href="07_01.php?search=<?php echo $search ?>&sortby=Name">Name</a></th>
                <th><a href="07_01.php?search=<?php echo $search ?>&sortby=Model+Number">Model Number</a></th>
                <th><a href="07_01.php?search=<?php echo $search ?>&sortby=Price">Price</a></th>
                <th><a href="07_01.php?search=<?php echo $search ?>&sortby=Created+At">Created At</a></th>
                <th><a href="07_01.php?search=<?php echo $search ?>&sortby=Created+By">Created By</a></th>
            </tr>
            <?php echo $rows; ?>
        </table>
        <form action="07_02.php" method="get">
            <p><input type="submit" value="New Product" /></p>
        </form>
    </body>
</html>
