<?php
# For security reasons, these lines should be
# included from a file above the web directory
define('FM_HOST', '127.0.0.1');
define('FM_FILE', 'Product Catalog');
define('FM_USER', 'esmith');
define('FM_PASS', 'm4rg0t');

# this is the include for the API for PHP
require_once ('FileMaker.php');

# instantiate a new FileMaker object
$fm = new FileMaker(FM_FILE, FM_HOST, FM_USER, FM_PASS);

# make sure there is a product ID
if (empty($_GET['recid'])) {
    die('The record id is missing.');
}

# get the record by its internal id
$record = $fm->getRecordById('Product', $_GET['recid']);

# if the user posted a new portal record, submit it to FileMaker
if (isset($_POST['new_portal_row'])) {
  $new_row = $record->newRelatedRecord('Inventory');
  $new_row->setField('Inventory::Location', $_POST['location']);
  $new_row->setField('Inventory::Quantity', $_POST['quantity']);
  $result = $new_row->commit();
  
  # re-pull the record from FMP to display the update
  $record = $fm->getRecordById('Product', $_GET['recid']);
}

# set vars for output below
$id = $record->getField('ID');
$name = $record->getField('Name');
$model_number = $record->getField('Model Number');
$price = $record->getField('Price');
$created_at = $record->getField('Created At');
$created_by = $record->getField('Created By');

# grab records from portal as an array of record objects
$portal_records = $record->getRelatedSet('Inventory');

# start compiling the html for the portal table
$portal_html = '<form action="08_02.php?recid=' . $record->getRecordId() . '" method="post">';
$portal_html.= '<table border="1">';
$portal_html.= '<tr>';
$portal_html.= '<th>Location</th>';
$portal_html.= '<th>Quantity</th>';
$portal_html.= '<th>&nbsp;</th>';
$portal_html.= '</tr>';

# loop through the array of portal record objects
foreach($portal_records as $portal_record) {
  $portal_html.= '<tr>';
  $portal_html.= '<td>' . $portal_record->getField('Inventory::Location') . '</td>';
  $portal_html.= '<td>' . $portal_record->getField('Inventory::Quantity') . '</td>';
  $portal_html.= '<td>';
  $portal_html.= '<a href="08_04.php?recid='.$portal_record->getRecordId().'">edit</a>';
  $portal_html.= '&nbsp;';
  $portal_html.= '<a href="08_05.php?recid='.$portal_record->getRecordId().'">delete</a>';
  $portal_html.= '</td>';
  $portal_html.= '</tr>';
}

# attach a "new portal row" form to the end of the table
$portal_html.= '<tr>';
$portal_html.= '<td><input type="text" name="location" value="" /></td>';
$portal_html.= '<td><input type="text" name="quantity" value="" /></td>';
$portal_html.= '<td><input type="submit" name="new_portal_row" value="Save" /></td>';
$portal_html.= '</tr>';
$portal_html.= '</table>';
$portal_html.= '</form>';
?>
<html>
  <head>
    <title>08_03</title>
  </head>
  <body>
    <table border="1">
      <tr>
        <th>ID</th>
        <td><?php echo $id; ?></td>
      </tr>
      <tr>
        <th>Name</th>
        <td><?php echo $name; ?></td>
      </tr>
      <tr>
        <th>Model Number</th>
        <td><?php echo $model_number; ?></td>
      </tr>
      <tr>
        <th>Price</th>
        <td><?php echo $price; ?></td>
      </tr>
      <tr>
        <th>Created At</th>
        <td><?php echo $created_at; ?></td>
      </tr>
      <tr>
        <th>Created By</th>
        <td><?php echo $created_by; ?></td>
      </tr>
    </table>
    <?php echo $portal_html; ?>
  </body>
</html>
