<?php
# For security reasons, these lines should either be included from a
# config file above the web directory, or possibly captured during a
# login and stored in the SESSION superglobal array
define('FM_HOST', '127.0.0.1');
define('FM_FILE', 'Product Catalog.fp7');
define('FM_USER', 'esmith');
define('FM_PASS', 'm4rg0t');
#
# this is the include for the API for PHP
require_once ('FileMaker.php');
#
# instantiate a new FileMaker object
$fm = new FileMaker(FM_FILE, FM_HOST, FM_USER, FM_PASS);
#
# make sure there is a product ID
if (empty($_GET['recid'])) {
    die('The record id is missing.');
}
#
# store the internal record id
$recid = $_GET['recid'];
#
# set the layout name for this page
$layout_name = 'Product';
#
# initialize some variables
$page_content = '';
#
# get the layout as an object
$layout = $fm->getLayout($layout_name);
#
# get the fields from the layout as an array of objects
$fields = $layout->getFields();
#
# get the record by its internal id
$record = $fm->getRecordById($layout_name, $recid);
#
# check for errors
if (FileMaker::isError($record)) {
    die('<p>' . $record->getMessage() . ' (error ' . $record->code . ')</p>');
}
#
# start compiling our output
$page_content.= '<table border="1">';
foreach($fields as $field) {
    $field_name = $field->getName();
    $field_data_type = $field->getResult();
    if ($field_data_type == 'container') {
        $field_val = '<img src="get_image.php?path=' . urlencode($record->getField($field_name)) . '" />';
    } else {
        $field_val = $record->getField($field_name);
        $field_val = nl2br($field_val);
    }
    $page_content.= '<tr><th>' . $field_name . '</th><td>' . $field_val . '</td></tr>';
}
$page_content.= '</table>';
#
# check the layout for portals
$portals = $layout->getRelatedSets();
foreach($portals as $portal) {
    # get the name of the current related set
    $portal_name = $portal->getName();
    #
    # start compiling the portal table
    $page_content.= '<table border="1">';
    #
    # loop through the portal fields to draw the table header row
    $page_content.= '<tr>';
    $fields = $portal->getFields();
    foreach($fields as $field) {
        # related fields are returned with double colons in the name, so remove them
        $field_name = $field->getName();
        $page_content.= '<th>' . str_replace('::', ' ', $field_name) . '</th>';
    }
    $page_content.= '</tr>';
    #
    # get the records related to this record, based on the portal name
    $related_records = $record->getRelatedSet($portal_name);
    #
    # if there are no related records in the portal, filemaker will return an error
    if (FileMaker::isError($related_records)) {
        $page_content.= '<td colspan="' . count($fields) . '">no related records</td>';
    } else {
        foreach($related_records as $related_record) {
            foreach($fields as $field) {
                $field_name = $field->getName();
                $field_data_type = $field->getResult();
                if ($field_data_type == 'container') {
                    $field_val = '<img src="get_image.php?path=' . urlencode($related_record->getField($field_name)) . '" />';
                } else {
                    $field_val = $related_record->getField($field_name);
                    $field_val = nl2br($field_val);
                }
                $page_content.= '<td>' . $field_val . '</td>';
            }
            $page_content.= '</tr>';
        }
    }
    $page_content.= '</table>';
}
?>
<html>
    <head>
        <title>Product</title>
    </head>
    <body>
        <p><a href="product_list.php">Product List</a></p>
<!-- BEGIN DYNAMIC OUTPUT -->        
<?php echo $page_content; ?>
<!-- END DYNAMIC OUTPUT -->        
    </body>
</html>
