<?php
# For security reasons, these lines should be
# included from a file above the web directory
define('FM_HOST', '127.0.0.1');
define('FM_FILE', 'Product Catalog');
define('FM_USER', 'esmith');
define('FM_PASS', 'm4rg0t');
#
# this is the include for the API for PHP
require_once ('FileMaker.php');
#
# instantiate a new FileMaker object
$fm = new FileMaker(FM_FILE, FM_HOST, FM_USER, FM_PASS);
#
# create a new search transaction
$request = $fm->newFindCommand('Product Request');
$request->addFindCriterion('Inventory::Location', 'Providence');
$request->setResultLayout('Product List');
#
# execute the search transaction
$result = $request->execute();
#
# check for errors
if (FileMaker::isError($result)) {
    $error_code = $result->code;
    if ( $error_code == 401 ) {
        die ('<p>Sorry, no records found. Please try again.</p>');
    } else {
        die('<p>' . $result->getMessage() . ' (error ' . $result->code . ')</p>');
    }
}
#
# get the result record set as an array of record objects
$records = $result->getRecords();
#
# loop through records compiling row html
$rows = '';
foreach($records as $record) {
    $rows.= '<tr>';
    $rows.= '<td>' . $record->getField('Name') . '</td>';
    $rows.= '<td>' . $record->getField('Model Number') . '</td>';
    $rows.= '<td>' . $record->getField('Price') . '</td>';
    $rows.= '</tr>';
}

?>
<html>
    <head>
        <title>Products</title>
    </head>
    <body>
        <table border="1">
            <tr>
                <th>Name</th>
                <th>Model Number</th>
                <th>Price</th>
            </tr>
            <?php echo $rows; ?>
        </table>
    </body>
</html>
