<?php
# this is the include for the sensitive info
require_once ('../private/connection_info.php');
#
# this is the include for the API for PHP
require_once ('FileMaker.php');
#
# instantiate a new FileMaker object
$fm = new FileMaker(FM_FILE, FM_HOST, FM_USER, FM_PASS);
#
# store the current page name
$this_page = basename($_SERVER['PHP_SELF']);
#
# create a new search transaction
if (isset($_GET['search']) and $_GET['search'] != '') {
    $search = $_GET['search'];
    $request = $fm->newFindCommand('Product');
    $request->addFindCriterion('Name', $search);
} else {
    $search = '';
    $request = $fm->newFindAllCommand('Product');
}
#
# specify sort by field, if any
if (isset($_GET['sortby']) and $_GET['sortby'] != '') {
    $request->addSortRule($_GET['sortby'], 1);
}
#
# execute the search transaction
$result = $request->execute();
#
# check for errors
if (FileMaker::isError($result)) {
    if ( $result->code == 401 ) {
        die('<p>No records found. Please <a href="'.$this_page.'">try again</a>.');
    } else {
        die('<p>' . $result->getMessage() . ' (error ' . $result->code . ')</p>');
    }
}
#
# get the result record set as an array of record objects
$records = $result->getRecords();
#
# loop through record objects compiling row html
$rows = '';
foreach($records as $record) {
    $rows.= '<tr>';
    $rows.= '<td><a href="product.php?recid=' . $record->getRecordId() . '">edit</a></td>';
    $rows.= '<td>' . $record->getField('ID') . '</td>';
    $rows.= '<td>' . $record->getField('Name') . '</td>';
    $rows.= '<td>' . $record->getField('Model Number') . '</td>';
    $rows.= '<td>' . $record->getField('Price') . '</td>';
    $rows.= '<td>' . $record->getField('Created At') . '</td>';
    $rows.= '<td>' . $record->getField('Created By') . '</td>';
    $rows.= '</tr>';
}
?>
<html>
    <head>
        <title>Product List</title>
    </head>
    <body>
        <form action="<?php echo $this_page ?>" method="get">
            <p>
                Product Name Search: 
                <input type="text" name="search" />
                <input type="submit" value="Go" />
            </p>
        </form>
        <table border="1">
            <tr>
                <th>Edit</th>                                       
                <th><a href="<?php echo $this_page ?>?search=<?php echo $search ?>&sortby=ID">ID</a></th>
                <th><a href="<?php echo $this_page ?>?search=<?php echo $search ?>&sortby=Name">Name</a></th>
                <th><a href="<?php echo $this_page ?>?search=<?php echo $search ?>&sortby=Model+Number">Model Number</a></th>
                <th><a href="<?php echo $this_page ?>?search=<?php echo $search ?>&sortby=Price">Price</a></th>
                <th><a href="<?php echo $this_page ?>?search=<?php echo $search ?>&sortby=Created+At">Created At</a></th>
                <th><a href="<?php echo $this_page ?>?search=<?php echo $search ?>&sortby=Created+By">Created By</a></th>
            </tr>                                                   
            <?php echo $rows; ?>
        </table>
    </body>
</html>
